
Object sc_3
  class Scene,
  with
	number 3,
	init_scene [;
		SetQuestion(q3_1);
	],
	begin_scene [ rock;
		tossguards.startup();
		baitguards.work_target = 0; ! ensure this is true until they come out
		equiptalker.number = 0;
		give equiptalker ~general;
		StartDaemon(equiptalker);
		give tossmetaldoor ~open;
		switch (rock) {
			1: ! first time in
				move activeplayer to TossJunction;
				SaveToolPositions();
				move equiptalker to SouthFrontier;
				give equiptalker ~general;
			2, -1, -2: ! all subsequent times (including boom/splat)
				move activeplayer to TossJunction;
				RestoreToolPositions();
		}
	],
	end_scene [ rock subrock   wasbait;
		wasbait = (baitguards in TossJunction);
		tossguards.shutdown();
		baitguards.shutdown();
		dooropenguards.shutdown();
		StopDaemon(equiptalker);
		switch (rock) {
			-1:
				if (wasbait && anywherein(acidpack, DeadEndHall)) {
					SetQuestion(q3_d10);
					rtrue;
				}
				SetAcidQuestions(subrock);
			-2:
				if (wasbait && anywherein(blasttab, DeadEndHall)) {
					SetQuestion(q3_d9);
					rtrue;
				}
				SetBlastQuestions(subrock);
			-3: ! security door open
				" ,   . --! []";
			1: ! guards stumble across you in the hall
				if (q3_d1 hasnt general) {
					give q3_d1 general;
					SetQuestion(q3_d1);
				}
				else if (q3_d1r hasnt general) {
					give q3_d1r general;
					SetQuestion(q3_d1r);
				}
				else {
					SetQuestion(q3_d1rr);
				}
			2: ! guards are baited, then see you.
				! subrock: 1 = threw a second item; 2 = junction door opened
				if (q3_d2 hasnt general) {
					give q3_d2 general;
					SetQuestion(q3_d2, subrock);
				}
				else {
					SetQuestion(q3_d2r, subrock);
				}
			3: ! woman sees you
				if (q3_d3 hasnt general) {
					give q3_d3 general;
					SetQuestion(q3_d3);
				}
				else {
					SetQuestion(q3_d3r);
				}
			4: ! back across red line
				if (q3_d4 hasnt general) {
					give q3_d4 general;
					SetQuestion(q3_d4);
				}
				else {
					SetQuestion(q3_d4r);
				}
			5: ! guards see open door, then you
				if (q3_d5 hasnt general) {
					give q3_d5 general;
					SetQuestion(q3_d5);
				}
				else {
					SetQuestion(q3_d5r);
				}
			6: ! hide in closet
				if (q3_d6 hasnt general) {
					give q3_d6 general;
					SetQuestion(q3_d6);
				}
				else {
					SetQuestion(q3_d6r);
				}
			7: ! left tools behind
				SetQuestion(q3_d7, subrock);
			8: ! baited with wrong item
				if (q3_d8 hasnt general) {
					give q3_d8 general;
					SetQuestion(q3_d8, subrock);
				}
				else if (q3_d8r hasnt general) {
					give q3_d8r general;
					SetQuestion(q3_d8r, subrock);
				}
				else {
					SetQuestion(q3_d8rr, subrock);
				}
			9: ! blew up baited guards
				SetQuestion(q3_d9);
			10: ! sprayed baited guards
				SetQuestion(q3_d10);
			20: ! success
				SetScene(sc_4);
		}
	];

! Emotional status to date:
! Minimum: 2 helpful, nothing else.
! Maximum: 2 blatant lies, 2 sneaky lies, 3 stubborns, 3 angries, 2 stupid.
!   Probably a little more, actually.
! (That's not counting acid/blast queries, which are 1 sneaky, 3 blatant,
! 3 stubborn, 1 angry; or 1 helpful.)

Object q3_1
  class Question,
  with
	query [;
		print "^   . @<<      ,    .   , --  ,";
		if (num_helpfuls >= num_stubborns)
			print "  ";
		else
			print "  ";
		if (scrambler has general) {
			print ", --     ,   ";
			if (q2_d3 hasnt general)
				print "    .      ", (emphstring) "", "   ,            .      .   ,";
			else
				print "   .    ,       .      .   ,";
		}
		else {
			print ". @<<  ,";
		}
		print "           ,      @>>.   . @<<      ?@>>^";
	],
	time_limit 6,
	daemon [;
		if (self.number == 3) {
			print "^@<<,         .   ,     ,       .  ?@>>^";
		}
	],
	answer_yes [; 
		if (num_blatant_lies + num_sneaky_lies >= 2) 
			print "@<<   .";
		else
			print "@<<   .";
		num_sneaky_lies++;
		print "   ,      ,    ,   ...@>>";
		SetQuestion(q3_2);
	],
	answer_no [;
		num_helpfuls++;
		print "@<<.     ,    ,   ...@>>";
		SetQuestion(q3_2);
	],
	answer_wait [;
		if (num_wait_answers > num_yes_answers + num_no_answers)
			print "@<<,       ,     .";
		else
			print "@<<,        ?";
		num_stubborns++;
		print "   ,      ,    ,   ...@>>";
		SetQuestion(q3_2);
	];

Object q3_2
  class Question,
  with
	query "  ,   ,      ,     ,    , .    : @<<,    ,      ,       ?@>>     .",
	time_limit 5,
	answer_yes [;
		num_stubborns++;
		print "@<<,    .      ", (emphstring) "", " .    .      ,       @>>.^";
		SetQuestion(q3_3, 1);
	],
	answer_no [;
		num_cosmos++;
		print "@<<,    .      ", (emphstring) "", " .    .      ,       @>>.^";
		SetQuestion(q3_3, 0);
	],
	answer_wait [;
		if (num_helpfuls >= 1 && num_got_angry == 0)
			print "  . @<<  . ";
		else
			print "  . @<<  ...   @>>.      . @<<";
		print "   .      ", (emphstring) "", " .    .      ,       @>>.^";
		SetQuestion(q3_3, 2);
	];

Object q3_3
  class Question,
  with
	query [; rtrue; ],
	time_limit 3,
	answer_general [;
		print "@<<  --     @>>.^^   . @<<     .";
		if (num_blatant_lies + num_sneaky_lies >= 3) 
			print " , ,     .";
		else if (num_stubborns >= 3)
			print "   ,     ;    ", (emphstring) "", " .";
		else
			print "  ,   .";
		print "     ...@>>^";
		BeginScene(1);
	],
	answer_yes [;
		num_helpfuls++;
		self.answer_general();
	],
	answer_no [;
		num_jingos++;
		self.answer_general();
	],
	answer_wait [;
		num_sneaky_lies++;
		self.answer_general();
	];

Object q3_d1
  class Question,
  with
	query "^@<< ,     --   . ,    .   ,      .  ?@>>",
	time_limit 3,
	answer_yes [;
		if (num_sneaky_lies + num_blatant_lies >= 3)
			print "@<<,   -- , --   . -- ";
		else
			print "@<<-.     . ";
		print "     .    @>>.^";
		num_blatant_lies++;
		BeginScene(2);
	],
	answer_no [;
		print "@<<";
		if (num_helpfuls <= 1)
			print "-,    ! ";
		print ".   @>>.^";
		num_helpfuls++;
		BeginScene(2);
	],
	answer_wait [;
		print "    . @<<  ,    .    ,   ", (emphstring) "", " ;     ,      .      ,    .";
		if (num_got_angry >= 2 || num_stubborns >= 4)
			print "  , --  , --    .      ";
		else
			print "  ,     ";
		print "@>>.^";
		num_stubborns++;
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q3_d1r
  class Question,
  with
	query "^@<<, ,   .    ,     ,   .   ,  -      .     .       . ?@>>",
	time_limit 3,
	answer_yes [;
		print "@<<@>>.^";
		BeginScene(2);
	],
	answer_no [;
		print "    . @<<.     @>>.    .^";
		BrainDrain();
	],
	answer_wait [;
		num_got_angry++;
		print "    . @<<    ", (emphstring) "-", "  ?    ,       .    ,  @>>.     ,  .^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked
	
Object q3_d1rr
  class Question,
  with
	query [;
		print "^@<<     @>>.    ,    .^";
		BeginScene(2);
	];

Object q3_d2
  class Question,
  with
	query [;
		print "^@<<,   .    ,      ;  ,  ,   .    ,   ", (emphstring) ".";
		if (self.variant == 1) 
			print " ,  ,   ,    .";
		if (self.variant == 2) 
			print " ,  ,  ,    .";
		"      ?@>>";
	],
	time_limit 2,
	answer_yes [;
		print "    . @<<? , , @>>.^";
		BeginScene(2);
	],
	answer_no [;
		print "@<<.    @>>.^";
		BeginScene(2);
	],
	answer_wait [;
		num_stubborns++;
		print "    . @<< , @>>.^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q3_d2r
  class Question,
  with
	query [;
		print "^@<< ,    --  ,   ", (emphstring) "", "  ";
		if (self.variant == 2) 
			print "         ";
		print "@>>.    ,    .^";
		BeginScene(2);
	];

Object q3_d3
  class Question,
  with
	query [;
		new_line;
		if (num_sneaky_lies >= 2)
			print "@<<  ,   .";
		else if (num_blatant_lies >= 2)
			print "@<<,  - ", (emphstring) "", "  ,   .";
		else
			print "@<<? .";
		print " ";
		if (q3_d1 has general || q3_d2 has general)
			print "    ";
		else
			print "   ";
		print "@>>.    .^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q3_d3r
  class Question,
  with
	query [;
		print "^@<<,   ,        @>>.    .^";
		BeginScene(2);
	];

Object q3_d4
  class Question,
  with
	query "^@<< .          .    .  ,      @>>, --    . @<<    .      , ?     @>>.",
	time_limit 4,
	answer_yes [;
		num_cosmos++;
		num_helpfuls++;
		print "@<<!@>>";
		SetQuestion(q3_d41);
	],
	answer_no [;
		num_cosmos++;
		print "@<<   ?        @>>.";
		SetQuestion(q3_d41);
	],
	answer_wait [;
		num_jingos++;
		if (num_got_angry == 0) {
			print "@<<,  ,     --      @>>.       . @<<    . @>>.    ,   ,  .^";
		}
		else {
			print "@<<,  ,     @>>, --   .    .^";
		}
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q3_d41
  class Question,
  with
	query "        . @<<      ,    ,  ?   ,    @>>.",
	time_limit 4,
	answer_yes [;
		print " . @<<  .";
		if (num_helpfuls >= 1 && num_stubborns <= 2) 
			print "    .";
		else {
			print "   ";
			if (num_got_angry)
				print " --  ,    .";
			else
				print " --  ,     .";
		}
		print "   , --   , --      @>>.   .^";
		num_cosmos++;
		BeginScene(2);
	],
	answer_no [;
		print "@<<, .          ...@>>      -. @<<  ,      ,     @>>.      .^";
		BeginScene(2);
	],
	answer_wait [;
		print "@<<?   ?";
		if (num_helpfuls >= 1 && num_stubborns <= 2) 
			print "   --   ";
		else 
			print " ,   .     ";
		print "@>>.      .^";
		BeginScene(2);
	];

Object q3_d4r
  class Question,
  with
	query [;
		print "^@<<  ,  ,       @>>.   .^";
		BeginScene(2);
	];

Object q3_d5
  class Question,
  with
	query [;
		new_line;
		if (num_blatant_lies >= 2)
			print "@<<     .";
		else if (num_sneaky_lies >= 2)
			print "@<<     .";
		else
			print "@<<  .";
		print "     ,    ,     @>>.^";
		num_dumb_recall++;
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q3_d5r
  class Question,
  with
	query [;
		print "^@<<  ,    .     ,  ,   @>>.^";
		BeginScene(2);
	];

Object q3_d6
  class Question,
  with
	query [;
		print "^      . @<<,    ,   .   ,          ?    ", (emphstring) "", " --    @>>.^^  . @<<    ,     ,      ,  ", (emphstring) "", "      .  @>>.  -      . @<< ,    ?@>>^";
	],
	time_limit 2,
	answer_yes [;
		num_stubborns++;
		print "@<<  @>>.   .^";
		BeginScene(2);
	],
	answer_no [;
		num_got_angry++;
		num_stubborns++;
		print "@<<  ?           ? ,   @>>.   .^";
		BeginScene(2);
	],
	answer_wait [;
		num_stubborns++;
		print "@<<, .  . ", (emphstring) "", " ,  @>>.     .^";
		BeginScene(2);
	];

Object q3_d6r
  class Question,
  with
	query [;
		print "^@<<, .   ,    ,  ,    ,   ,      --@>>^^       ,         ,     . @<< ?      -- , ", (emphstring) ",", "  ", (emphstring) "", " --@>>     . @<<,    !@>> --  ,      ,      .       .^";
		BrainDrain();
	];

Object q3_d7
  class Question,
  with
	query [;
		print "^@<<,  ,     .";
		if (self.variant == 1)
			print "    ";
		else
			print "     ", (cGen) self.variant, ",   ";
		! print " left behind";
		print ".  ,       @>>.^";
		BeginScene(2);
	];

Object q3_d8
  class Question,
  with
	query [;
		print "^@<<      .       ", (cIns) self.variant, ",      ,    . ?@>>^";
	],
	time_limit 4,
	answer_yes [;
		print "@<<...    ", (cAcc) self.variant, "   @>>.   ,      . @<< ", (PronounS) self.variant, ", , ", (V2bEnd) self.variant, "    . , ,  ,      .    ,      @>>.    .^";
		BeginScene(2);
	],
	answer_no [;
		print "@<<...,   ,   ,      .   ,      . @<< ", (PronounS) self.variant, ", , ", (V2bEnd) self.variant, "    . , ,  ,      .    ,      @>>.    .^";
		BeginScene(2);
	],
	answer_wait [;
		print "  ,      . @<<~", (CCNom) self.variant, "~     .   ,    ", (GenIt) self.variant, "   .      ,     ,      ,      @>>.    .^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q3_d8r
  class Question,
  with
	query [;
		num_dumb_recall++;
		print "^@<<,   ,   .     ,   ", (VPEnd) self.variant, " ", (cNom) self.variant, ";    , ,   . , --   , --     ,       . .   @>>.     ,    .^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q3_d8rr
  class Question,
  with
	query [;
		print "^@<<,   , ", (VPEnd) self.variant, "  ", (cNom) self.variant, ",  ";
		if (self.variant == acidpack)
			print "@>>.    - .";
		else
			print ", --    . --";
		print "  ,     ,      -  @>>.     ,    .^";
		BeginScene(2);
	];

Object q3_d9
  class Question,
  with
	query [;
		print "^@<<  -- - ,   .   - ,    ,     @>>.     ,    .^";
		BeginScene(2);
	];

Object q3_d10
  class Question,
  with
	query [;
		print "^@<<,   .   - ,    ,    ,     ,         --  ? --      @>>.     ,    .^";
		BeginScene(2);
	];


! ------------- The pick-throwing scene

Object tossguards "/"
  with
	name '' '' '' '' '' '',
	short_name [;
		if (self.work_target == location)
			print "";
		else
			print " ";
		rtrue;
	],
	found_in [; rtrue; ], ! they're everywhere!
	! ok, not exactly everywhere. This is where they're visible. 
	work_target 0, 
	dir_name [ case;
		! switch on where you are, not on where the guards are.
		switch (location) {
			TossJunction: print "";
			SouthFrontier: print "";
			DeadEndHall: print "";
			default: print "( ", (cNom) location, ") []";
		}
		if (case == 'gen') {
			print "";
		}
		if (case == 'dat') {
			print "";
		}
		rtrue;
	],
	description [;
		if (self.work_target == location)
			"      .      ,    .";
		else
			print_ret "  , -   ,  ", (nop) self.dir_name('gen'), ".";
	],
	react_before [;
		Listen:
			if (noun == 0) {
				print "(", (cGen) self, ")^";
				<<Listen self>>;	
			}
		Hide:
			if (self.work_target == location)
				return L__M(##Hide, 2);
			else
				return L__M(##Hide, 4);
	],
	before [ ix;
		Examine:
			rfalse;
		Listen:
			if (self.work_target == location) {
				print " c ", (nop) self.dir_name('gen');
				if (self.number2 == -1) {
					ix = 0;
				}
				else {
					ix = random(7) - 1;
					if (ix == self.number2)
						ix = random(7) - 1;
				}
				self.number2 = ix;
				switch (ix) {
					0: print "  : -   ,   .";
					1: print "  : -   .";
					2: print "  : -   .";
					3: print "  : -       .";
					default: print " .";
				}
				"     .";
			}
			else if (self.work_target == SecurityBranch 
				&& location == SouthFrontier or DeadEndHall)
				print_ret "       ", (nop) self.dir_name('gen'), ".";
			else {
				print " ,   ", (nop) self.dir_name('gen'), ",   .";
				if (self.number2 == -1) {
					ix = 0;
				}
				else {
					ix = random(5) - 1;
					if (ix == self.number2)
						ix = random(5) - 1;
				}
				self.number2 = ix;
				switch (ix) {
					0: print "    , -     .";
					1: print "    , -    .";
					2: print "    , -   .";
				}
				new_line;
				rtrue;
			}
		default:
			if (self.work_target == location)
				print_ret " --     ", (nop) self.dir_name('dat'), ".";
			else
				"    ,    .";
	],
	life [;
		<<Touch self>>;
	],
	startup [;
		tossguards.number = 0;
		tossguards.number2 = -1;
		tossguards.work_target = SecurityBranch;
		give tossguards ~absent;
		give tossguards ~general; ! no see warning
		StartDaemon(tossguards);
	],
	shutdown [;
		StopDaemon(self);
		give self absent;
		self.work_target = 0;
		remove self;
	],
	number 0, ! daemon counter
	number2 0, ! talking counter
	daemon [;
		self.number++;
		
		! Do
		switch (self.number) {
			5:
				self.work_target = TossJunction;
				if (location == TossJunction)
					print_ret "^        --   ,     .    ,     .";
			11:
				self.work_target = SouthFrontier;
				if (location == SouthFrontier) {
					print_ret "^   - ,     - .   ,  ,      ,   .";
				}
				else if (location == DeadEndHall or TossJunction) {
					print "^  - . , ,  ,     ,    .   ,     .     .^";
					EndScene(1);
					rtrue;
				}
			17:
				print "^  - .            .       .      .^";
				EndScene(1);
				rtrue;
		}
		
		! See
		if (self.work_target == SouthFrontier 
			&& location == TossJunction or DeadEndHall) {
			print "^  . []^";
		}
		else if (self.work_target == SecurityBranch 
			&& location == SouthFrontier or DeadEndHall) {
			! very far
			if (self.number % 2 == 0)
				print "^-   ", (nop) self.dir_name('gen'), "   .^";
		}
		else if (self.work_target ~= location) {
			! far
			switch (self.number) {
				1:
					print "^   ,  -  ", (nop) self.dir_name('gen'), ".^";
				2:
					print "^,   .^";
				5:
					if (location == DeadEndHall)
						print "^   .^";
				10:
					if (location == DeadEndHall)
						print "^   ", (nop) self.dir_name('gen'), 
							"    .^";
					else
						print "^   ", (nop) self.dir_name('gen'), 
							"  .^";
				default:
					if (self.number % 2 == 0)
						print "^   ", (nop) self.dir_name('gen'), 
							"  .^";
			}
		}
		else {
			! near
			if (self.number == 4 or 10 or 16)
				print "^     ,  .^";
			else
				print "^ ,    .^";
		}
	],
  has scenery animate pluralname absent; ! general means you've gotten some see-warning

Object baitguards "/"
  with
	name '' '' '' '' '' '',
	description "  ,  ,   .   -,    --    ,     .      .",
	react_before [;
		Listen:
			if (noun == 0) {
				print "(", (cAcc) self, ")^";
				<<Listen self>>;	
			}
		Hide:
			return L__M(##Hide, 2);
	],
	before [;
		Examine:
			rfalse;
		Listen:
			"   .";
		default:
			"   .";
	],
	life [;
		<<Touch self>>;
	],
	work_target 0, ! the thing that got their attention
	startup [ targ;
		move self to TossJunction;
		self.work_target = targ;
		StartDaemon(self);
		self.number = 0;
		if (targ == 0)
			print "   . []^";
	],
	shutdown [;
		remove self;
		StopDaemon(self);
	],
	number 0,
	daemon [;
		self.number++;
		switch (self.number) {
			! number==1 happens the same turn as the startup
			2:
				print "^         .^";
			4:
				print "^   .      .          .^";
				EndScene(2);
				rtrue;
		}
	],
  has scenery animate pluralname; 

Object dooropenguards "/"
  with
	name '' '' '' '' '' '',
	description "    ,     --     ,      .",
	react_before [;
		Listen:
			if (noun == 0) {
				print "(", (cAcc) self, ")^";
				<<Listen self>>;	
			}
		Hide:
			return L__M(##Hide, 2);
	],
	before [;
		Examine:
			rfalse;
		Listen:
			" .";
		default:
			"   .";
	],
	life [;
		<<Touch self>>;
	],
	startup [;
		move self to TossJunction;
		StartDaemon(self);
		self.number = 0;
	],
	shutdown [;
		remove self;
		StopDaemon(self);
	],
	number 0,
	daemon [;
		self.number++;
		switch (self.number) {
			! number==1 happens the same turn as the startup
			2:
				print "^         .";
				if (player in TossJunction or DeadEndHall)
					print "     .^";
				else
					print "    - ,    --    ,      .^";
				EndScene(5);
				rtrue;
		}
	],
  has scenery animate pluralname; 

Object TossJunction "- "
  with
	description [;
		print "      ,    , ";
		if (tossmetaldoor has open)
			print " ";
		else
			print " ";
		print "   --  .";
		if (tossguards.work_target == self || dooropenguards in self)
			print "       ,      .";
		if (powercut == 0)
			print "  ,      .";
		if (baitguards in self)
			print "       ,   .";
		new_line;
		rtrue;
	],
	e_to [;
		if (tossguards.work_target == self) {
			if (tossguards hasnt general) {
				give tossguards general;
				"       ,    .";
			}
			print "     ,  .  ,     .^";
			EndScene(1);
			rtrue;
		}
		if (dooropenguards in self) {
			print "     ,  .  ,     .^";
			EndScene(5);
			rtrue;
		}
		if (baitguards in self) {
			print "   ,   .  ,          .^";
			EndScene(2);
			rtrue;
		}
		return DeadEndHall;
	],
	n_to [;
		if (tossguards.work_target == SecurityBranch) {
			PlayerTo(SecurityBranch, 2);
			print "^     ,     - .   ,     .     .^";
			EndScene(1);
			rtrue;
		}
		else if (tossguards.work_target == self) {
			if (tossguards hasnt general) {
				give tossguards general;
				"         .";
			}
			else {
				print "        .             .^";
				EndScene(1);
				rtrue;
			}
		}
		else if (tossguards.work_target ~= 0) {
			"     . []";
		}
		if (dooropenguards in self) {
			print "   ,    .         .^";
			EndScene(5);
			rtrue;
		}
		if (baitguards in self) {
			print "      ,    . ...      .        .^";
			TryPassGuards();
			rtrue;
		}
		return SecurityBranch;
	],
	w_to [;
		if (dooropenguards in self) {
			print "        .^";
			return SouthFrontier;
		}
		if (baitguards in self) {
			print "      ,   .    ,    ,         ,     .^";
			EndScene(2);
			rtrue;
		}
		if (escaping) {
			if (powercut == 0) { 
				"    ,      ,   . , ,    ,   .     ,         - .";
			}
		}
		return SouthFrontier;
	],
	s_to tossmetaldoor,
	cant_go "   ,     .";

Object -> tossend "/"
  with
	name '' '' '' '' '//' '',
	description [;
		if (powercut == 0)
			"     ,     .";
		else
			"   .";
	],
	react_before [;
		ThrowDir:
			if (second == e_obj)
				<<ThrowAt noun self>>;
	],
	before [;
		Examine:
			rfalse;
		Enter:
			<<Go e_obj>>;
		ThrownAt:
			if (escaping) {
				print (CCNom) noun, "   ", (V1bEnd) noun, "    .^";
				move noun to DeadEndHall;
				rtrue;
			}
			if (baitguards in TossJunction) {
				multi_interrupt = 1;
				print (CCNom) noun, "   ", (V1bEnd) noun,"    . ,  ,       .^";
				EndScene(2, 1);
				rtrue;
			}
			if (dooropenguards in TossJunction) {
				print (CCNom) noun, "   ", (V1bEnd) noun,"    . ,    ,     .^";
				move noun to DeadEndHall;
				rtrue;
			}
			switch (tossguards.work_target) {
				SecurityBranch:
					print (CCNom) noun, "   ", (V1bEnd) noun,"    .^";
					move noun to DeadEndHall;
					rtrue;
				TossJunction:
					print (CCNom) noun, "   ", (V1bEnd) noun,"    .^";
					move noun to DeadEndHall;
					print "^  : @<< ?@>>. @<<,     @>>, --     .^^  .    -      ,     ,   , ,   .^";
					tossguards.shutdown();
					baitguards.startup(noun);
					multi_interrupt = "(    - .)";
					rtrue;
				default: 
					print_ret (CCNom) noun, " ", (V1bEnd) noun, "   . []";
			}
		Receive:
			<<ThrowAt noun self>>;
		default:
			"   .";
	],
  has scenery male;

Object -> tossmetaldoor "/ /"
  class InteriorDoor,
  with
	name '//' '' '',
	description [;
		print "    .  ,      .";
		if (self has open)
			"  .";
		else
			"  .";
	],
	door_dir s_to,
	door_try [;
		if (tossguards.work_target == TossJunction)
			<<Touch self>>;
		if (self hasnt open) 
            return self.InteriorDoor::door_try2(); ! -- hacked
		print "     ,    . :    ,        ,     . ,  ,      .^";
		print "^ ,   .          .^";
		EndScene(6);
		rtrue;
	],
	react_before [;
		Take:
			if (noun == lockpick && lockpick in TossJunction 
				&& lockpick.work_target) {
				if (tossguards.work_target == TossJunction)
					<<Touch self>>;
			}
	],
	before [;
		ActivateTool:
			if (escaping) {
				if (location == TossJunction) {
					print "^ .     ,   ;  -    ,    .^^-    ,      .^";
				}
				else if (location == SecurityBranch or NortheastCorner or
					DeadEndHall or SouthFrontier) {
					print "^";
					switch (location) {
						SecurityBranch: print "  ";
						NortheastCorner: print "  ,    ,";
						DeadEndHall: print "  ";
						SouthFrontier: print "  ";
					}
					print "      . -    .^^-     ,      .^";
				}
				else {
					print "^-    .^";
				}
				SummonEsguardsSecurity();
				rtrue;
			}
			give self open;
			if (baitguards in TossJunction) {
				! we know player is in TossJunction too
				print "^    .      .       .^";
				EndScene(2, 2);
				rtrue;
			}
			else {
				if (location == TossJunction) {
					print "^,   .    ,   , .     .^";
				}
				else {
					print "^  .     .^";
				}
				tossguards.shutdown();
				dooropenguards.startup();
			}
			rtrue;
		Examine:
			rfalse;
		default:
			if (tossguards.work_target == TossJunction) {
				"    ,      .";
			}
	],
has female;

Object -> tossmetaldoorplate "/ /  "
  class InteriorPlate,
  with
	work_target tossmetaldoor,
	startup [;
		if (tossguards.work_target == TossJunction) {
			"  ,    . []";
		}
	],
	before [;
		Examine:
			rfalse;
		default:
			if (tossguards.work_target == TossJunction) {
				"    ,      .";
			}
	];

Object SouthFrontier " "
  with
	description "     -  ;     .",
	e_to [;
		if (tossguards.work_target == SecurityBranch) {
			return TossJunction;
		}
		else if (tossguards.work_target == TossJunction) {
			print "    ,    ,     .   ,    , ,  ,    .      ,     .^";
			return TossJunction;
		}
		else if (tossguards.work_target == self) {
			if (tossguards hasnt general) {
				give tossguards general;
				"         .";
			}
			else {
				print "        .             .^";
				EndScene(1);
				rtrue;
			}
		}
		else if (tossguards.work_target ~= 0) {
			"     . []";
		}
		return TossJunction;
	],
	nw_to [;
		if (escaping) {
			return SouthBoundary;
		}
		print "   ,   .^";
		EndScene(4);
		rtrue; 
	],
	s_to [;
		if (escaping) {
			return FinalEnd;
		}
		if (equiptalker in self) {
			if (equiptalker hasnt general) {
				give equiptalker general;
				PronounNotice(equiptalker);
				"         .  ,   ,  .  ,    ,    -   .    ,     .";
			}
			print "   ,    .    .   ,       ,     .     , ,      .   .^";
			EndScene(3);
			rtrue;
		}
		"  ! []";
	],
	cant_go "   -,     .";

Object equiptalker "/  "
  with
	name '' '' '' '//' '' '' '' '',
	description [;
		give self general;
		" ,   ,    ,  .         - .    .";
	],
	react_before [;
		ThrowDir:
			if (second == s_obj)
				<<ThrowAt noun self>>;
		Hide:
			if (self has general)
				return L__M(##Hide, 2);
	],
	before [;
		Examine:
			rfalse;
		Listen:
			"         .   ,   , ,   ,     ,    .       .";
		Enter:
			<<Go s_obj>>;
		ThrownAt:
			print (CCNom) noun, "   ", (V1bEnd) noun, "    .     ", (GenIt2) noun, ",   ,     .   ...^^   -       .^";
			EndScene(3);
			rtrue;
		Receive:
			<<ThrowAt noun self>>;
		default:
			"    .";
	],
	life [;
		Answer, Order:
			print "        .   ,      .   .^";
			EndScene(3);
			rtrue;
		default:
			"    .";
	],
	number 0, ! counter for daemon
	daemon_priority -2,
	daemon [;
		if (escaping || player == passiveplayer) {
			StopDaemon(self);
			print_ret "^   ", (emphstring) "", 
				"   . []";
		}
		if (player notin SouthFrontier) {
			if (self.number > 3)
				self.number = 3;
		}
		else {
			self.number++;
			switch (self.number) {
				3:
					if (self hasnt general) {
						give self general;
						print "^    .     ,    .          - .    .^";
					}
					else {
						print "^     .^";
					}
				5:
					print "^  .^";
				7:
					print "^   ,        ,     .^";
				9, 10:
					self.number = random(3); ! 0, 1, or 2
			}
		}
	],
  has scenery animate female; ! general means player has seen

Object DeadEndHall " "
  with
	description [;
		print "           . ";
		if (deadendmetaldoor hasnt open)
			print " ";
		else
			print " ";
		".";
	],
	w_to [;
		if (tossguards.work_target == TossJunction) {
			if (tossguards hasnt general) {
				give tossguards general;
				"    ,   ,     .   ,    , ,  ,    .       .";
			}
			print "     ,   .       ,     .  ,      .^";
			EndScene(1);
			rtrue;
		}
		return TossJunction;
	],
	n_to deadendmetaldoor,
	cant_go "    .";

Object -> deadendmetaldoor "/ /"
  class InteriorDoor,
  with
	name '//' '' '',
	description [;
		print "    .  ,      .";
		if (self has open)
			"  .";
		else
			"  .";
	],
	door_dir n_to,
	door_to WiringCloset,
	door_try [;
		if (self hasnt open) {
			self.InteriorDoor::door_try2(); ! -- hacked
			rtrue;
		}
		if (self.number2)
			print "     .          .^";
		rfalse;
	],
	before [;
		ActivateTool:
			if (~~escaping)
				"^ ,     . []";
			if (self has open)
				rtrue;
			give self open;
			StartDaemon(self);
			if (location == DeadEndHall)
				"^ .";
			if (location == TossJunction)
				"^ , , ,    ,  .";
			rtrue;
	],
	daemon_priority -25, ! very low and very late
	number2 0, ! for daemon; means closing automatically
	daemon [;
		if ((escaping == 0) || (powercut ~= 0)) {
			StopDaemon(self);
			"^    . []";
		}
		if (self.number2 > 0) {
			give self ~open;
			StopDaemon(self);
			self.number2 = 0;
			if (location == WiringCloset or DeadEndHall)
				print "^  .^";
			else if (location == TossJunction)
				print "^    .^";
			return;
		}
		if (lockpick.work_target ~= deadendmetaldoorplate) {
			self.number2 = 1;
			print "^  ,     .^";
		}
	], has female;

Object -> deadendmetaldoorplate "/ /  "
  class InteriorPlate,
  with
	work_target deadendmetaldoor,
	startup [ fn;
		if (escaping == 0) {
			if (self hasnt general) {
				give self general;
				fn = emphstring;
			}
			else {
				fn = normstring;
			}
			fn("      .");
			new_line;
			rtrue;
		}
		rfalse;
	],
  has ~general; ! general means did italic warning


[ TryPassGuards   ix;

	if (anywherein(blasttab, DeadEndHall)) {
		if (blasttab.work_target == timerswitch && timerswitch.number) {
			EndScene(9);
			rtrue;
		}
	}

	if (anywherein(acidpack, DeadEndHall)) {
		if (acidpack.work_target == timerswitch && timerswitch.number) {
			EndScene(10);
			rtrue;
		}
	}

	if (baitguards.work_target ~= lockpick) {
		EndScene(8, baitguards.work_target);
		rtrue;
	}

	ix = LeftToolsBehind(3);
	if (ix) {
		EndScene(7, ix);
		rtrue;
	}
		
	EndScene(20);
	rtrue;
];

