
Object sc_6
  class Scene,
  with
	number 6,
	init_scene [;
		SetQuestion(q6_1);
	],
	begin_scene [ rock;
		loseguardseast.startup();
		give finaldrawer ~open ~general;
		give hypervent ~open;
		give finaldoor ~open;
		switch (rock) {
			1: ! first time in
				move activeplayer to FakeFrontier; 
				! give FakeFrontier visited; ! Good idea? Dunno.
				SaveToolPositions();
			2, -1, -2, -3: ! all subsequent times (including boom/splat/pow)
				move activeplayer to FakeFrontier; 
				RestoreToolPositions();
				set_parent(poisonpen, activeplayer); ! the heck with subtlety
				move pennib to poisonpen;
				remove penstain;
		}
	],
	end_scene [ rock subrock;
		loseguardseast.shutdown();
		loneguard.shutdown();
		loseguardsnorth.shutdown();
		if (hypervent has general) {
			rock = 20; ! the paranoia override
		}
		switch (rock) {
			-1:
				if (q6_da1 hasnt general) {
					give q6_da1 general;
					SetQuestion(q6_da1);
				}
				else {
					SetQuestion(q6_dab1r);
				}
			-2:
				if (q6_db1 hasnt general) {
					give q6_db1 general;
					SetQuestion(q6_db1);
				}
				else {
					SetQuestion(q6_dab1r);
				}
			-3: ! security door open
				" ,   . --! []";
			-4: ! pen suicide
				SetQuestion(q6_dp1);
			-5: ! gun suicide
				SetQuestion(q6_dp1);
			1: ! run into guards in upper hallways (before loneguard)
				SetQuestion(q6_d1);
			2: ! lone guard shoots you
				SetQuestion(q6_d2);
			3: ! still holding everything
				SetQuestion(q6_d3);
			4: ! put everything in drawer
				SetQuestion(q6_d4, subrock);
			5: ! things in more than one place
				SetQuestion(q6_d5, subrock);
			20: ! he sees the vent
				SetScene(sc_7);
		}
	];

! Emotional status to date: (absolute strained maximums)
! Minimum: 8 helpful, 6 cosmos, nothing else.
! Maximum: 6 blatant lies, 4 sneaky lies, 12 stubborns, 6 angries, 7 stupid,
!   7 jingos, 4 dumb recall.
! (That's not counting acid/blast queries, which are 1 sneaky, 3 blatant,
! 3 stubborn, 1 angry; or 1 helpful.)
! In startup: +1 dumb recall.

Object q6_1
  class Question,
  with
	query [;
		print "^@<<  @>>. ";
		print " . @<<  , ,  . ,         . ... ,    ,   .    ,     @>>.      .    ,    ,   .^^";
		print "@<<...        ?";
		if (SecurityOffice hasnt general) {
			print " ,       ,      .   ?";
		}
		if (OfficeSketchNumHanging() ~= 3) {
			print "  ,     --  -   ,      .   ?";
			OfficeSketchStartup();
		}
		print " , , ,  , - ,   ?@>>^";
	],
	time_limit 4,
	answer_yes [;
		num_dumb_recall++;
		print "@<<   .     ,   ,      .      ,      - .    @>>.   .^";
		SetQuestion(q6_2);
	],
	answer_no [;
		print "@<< ,    ?  ,    @>>.       .      .^";
		SetQuestion(q6_2);
	],
	answer_wait [;
		self.answer_yes();
	];

Object q6_2
  class Question,
  with
	query [ ix;
		print "^@<<     ?";
		if (num_blatant_lies + num_sneaky_lies >= 4) {
			print "      ";
			if (num_blatant_lies - num_sneaky_lies >= 3)
				print ",  ";
			else if (num_blatant_lies - num_sneaky_lies <= -2)
				print ",   ,    ";
			ix = 1;
		}
		else {
			print "     ";
			ix = 2;
		}
		if (num_stubborns - num_helpfuls >= 4) {
			if (ix == 2)
				print ",   - ;  ";
			else
				print ". ";
			print "       ";
		}
		else if (num_stubborns - num_helpfuls <= -2) {
			if (ix == 1)
				print ".  ";
			else
				print ". ";
			print "   ,    ,   ";
		}
		else {
			print ";  :    ,    ";
		}
		if (num_got_angry > 1) {
			print ".    ";
			if (num_got_angry > 3)
				print "        ;";
			else
				print " - ;";
			print "  ";
		}
		else {
			print ".        ,    ,  - ,   ";
		}
		print ".         @>>.";
		print "^^   ,     . @<<       ,  . , , ,    .      ";
		if (num_jingos - num_cosmos < 1) {
			print ".  , ,  .  ",
				(emphstring) "", "         .  ,   @>>.  .";
			ix = 1;
		}
		else {
			print ". ..., ,  ,  .  ,    ,   -- ,     . ,      .    ,       @>>.   .";
			ix = 2;
		}
		if (num_stupids + num_dumb_recall > 5) {
			print "^^@<<";
			if (ix == 1)
				print "    ";
			else
				print "  ,     ";
			print ".   ,    --    .     ,   ";
		}
		else {
			print "^^@<<";
			if (ix == 2)
				print ",   , ";
			else
				print "";
			print " ,   ,      .     ,   ";
		}
		if (ix == 1)
			print ",         ";
		else
			print ",      -- .   ";
		print "@>>.^^        . @<< ?   ?   ,        @>>.^";
	],
	answer_general "    . @<<, ,  .       ,      ,      @>>.",
	answer_yes [;
		print "  ,    . @<< @>>.^^ ";
		self.answer_general();
		BeginScene(1);
	],
	answer_no [;
		print "@<<?     ?@>>   ,  ,   .^^ ";
		self.answer_general();
		BeginScene(1);
	],
	answer_wait [;
		print "@<< ?@>>    ";
		self.answer_general();
		BeginScene(1);
	];

Object q6_d1
  class Question,
  with
	query [;
		print "^@<<   ?      .         ,       @>>.^";
		BeginScene(2);
	];
	
Object q6_d2
  class Question,
  with
	query [;
		print "^@<<  ?  , ,  . .      ,   ,    ,    @>>.^";
		BeginScene(2);
	];

Global DumbGlobalGuardOut;

Object q6_d3
  class Question,
  with
	answer_general [;
		! ok, query_general
		if (self hasnt general)
			print "^@<<@>>.      . @<<    ,    .    .";
		else
			print "^@<<, ,      .";
		give self general;
		if (DumbGlobalGuardOut == 0)
			print "  ,      ,   .     .";
		rtrue;
	],
	query [;
		q6_d3.answer_general();
		print "          ,     .   , ,   ,      ", (emphstring) "",
			" .    ,      @>>.^";
		BeginScene(2);
	],
  has ~general; ! general, for once, means the answer_general variant

Object q6_d4
  class Question,
  with
	query [;
		q6_d3.answer_general();
		print "     ,     ";
		if (self.variant)
			print " --  ,    ";
		print ".    @>>.^";
		BeginScene(2);
	];
	
Object q6_d5
  class Question,
  with
	query [;
		q6_d3.answer_general();
		print "       ";
		if (self.variant)
			print ",       ";
		print ".           .    ,     @>>.^";
		BeginScene(2);
	];
	
Object q6_da1
  class Question,
  with
	query [;
		print "^@<<  .         .   ,        ,        ,      .   @>>.^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked
	
Object q6_db1
  class Question,
  with
	query [;
		print "^@<<.       .   ,        ,        ,      .   @>>.^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked
	
Object q6_dab1r
  class Question,
  with
	query [;
		print "^@<<.  ,  ,   --  @>>.^";
		BeginScene(2);
	];
	
Object q6_dp1
  class Question,
  with
	query [;
		print "^@<< ,           .     @>>.^";
		BeginScene(2);
	];
	
! ------------- The scene where you lose

Object loseguardseast "/   "
  with
	name '' '' '' '' '' '//' '' '',
	description "  .",
	react_before [;
		Listen:
			if (noun == nothing)
				<<Listen self>>;
		ThrowDir:
			if (second == e_obj or nw_obj)
				<<ThrowAt noun self>>;
		Hide:
			return L__M(##Hide, 2);
	],
	before [;
		Examine:
			rfalse;
		Listen:
			<<Examine self>>;
		Enter:
			<<Go e_obj>>;
		ThrownAt:
			print "  -    ", (cAcc) noun, 
				"  .      ,             -,        .^";
			EndScene(1, 0);
			rtrue;
		default:
			"   .";
	],
	life [;
		<<Touch self>>;
	],
	startup [;
		move self to FakeFrontier;
		move loseguardswest to FakeFrontier;
		self.number = 0;
		StartDaemon(self);
	],
	shutdown [;
		StopDaemon(self);
		remove self;
		remove loseguardswest;
	],
	number 0,
	daemon [;
		self.number++;
		switch (self.number) {
			1:
				print "^  ,   ,    ,   -...      ,   .           .^";
			2, 4:
				print "^    .^";
			3, 5:
				print "^  -  .^";
			6:
				print "^   -  .    ,   ,     - .            .       ,    .^";
				EndScene(1, 1);
				rtrue;
		}
	],
  has scenery animate pluralname;

Object loseguardswest "/   -"
  with
	name '' '' '' '' '' '' '' '',
	description "  .",
	before [;
		Examine:
			rfalse;
		Listen:
			<<Examine self>>;
		Enter:
			<<Go nw_obj>>;
		ThrownAt:
			<<ThrowAt noun loseguardseast>>;
		default:
			"   -.";
	],
	life [;
		<<Touch self>>;
	],
  has scenery animate pluralname;

Object loseguardsnorth 
  with
	!name '' '' '//' '' '',
	short_name [;
		if (self hasnt general)
			print "   ";
		else
			print "  ";
		rtrue;
	],
	parse_name [ n;
		n = 0;
		while (NextWord() == '' or '' or '' or '' or '' or '//') n++;
		return n;
	],
	description [;
		if (self hasnt general)
			"  - .";
		else
			"    : -  , -       .     .";
	],
	react_before [;
		Listen:
			if (noun == nothing)
				<<Listen self>>;
		ThrowDir:
			if (second == n_obj)
				<<ThrowAt noun self>>;
		Hide:
			if (loneguard in FinalEnd && loneguard hasnt general) {
				! he's there and awake
				return L__M(##Hide, 3);
			}
			else {
				if (self hasnt general)
					return L__M(##Hide, 4);
				"   .";
			}
	],
	before [;
		Examine:
			rfalse;
		ShootAttack:
			rfalse;
		AttackWith:
			if (second ofclass PulseGun)
				rfalse;
			<<Touch self>>;
		Listen:
			if (self hasnt general)
				"  - .";
			else
				"    ,   .     .";
		Enter:
			<<Go n_obj>>;
		ThrownAt:
			move noun to FakeFrontier;
			if (self hasnt general)
				print_ret "  ", (cAcc) noun, "   . ", (Pronoun) noun, "     ,        .";
			else
				print_ret "  ", (cAcc) noun, "   . ", (Pronoun) noun, "     ,      ", (GenIt2) noun, ".";
		default:
			print "";
			if (self hasnt general)
				"   ,  ...  .";
			else
				"    .";
	],
	life [;
		ShootAttack:
			if (self hasnt general)
				"   .";
			if (player in finalcabinet) {
				print "    ";
			}
			else {
				print "  ";
			}
			print "      --     .        .  ,  -  -- ,  ;      ,     - .^^";
			print "  .       ;  .     .        --  ,  --^^";
			print "       ,    .^";
			TryToDie();
			rtrue;
		default:
			<<Touch self>>;
	],
	startup [;
		move self to FinalEnd;
		self.number = 0;
		self.number2 = 0;
		give self ~general;
		StartDaemon(self);
	],
	shutdown [;
		StopDaemon(self);
		remove self;
	],
	number 0,
	number2 0, ! for door hack
	daemon [;
		if (finaldoor has open) {
			! this relies on this daemon happening after loneguard
			if (self.number2 == 0) {
				self.number2 = 1;
			}
			else {
				give finaldoor ~open;
				print "^ .^";
			}
		}
		self.number++;
		switch (self.number) {
			6:
				print "^     .";
				if (loneguard hasnt general) {
					print "         .^";
					self.number = 11;
				}
				else {
					new_line;
				}
			8, 10:
				print "^     .^";
			12:
				give self general;
				print "^@<<!@>> --    .     ,     - .    ";
				if (loneguard hasnt general) {
					print "  ";
				}
				else {
					print "  ";
					if (player in finalcabinet)
						print "  ";
					else
						print "   ";
				}
				print ",     .^";
			13:
				print "^        .";
				if (loneguard hasnt general)
					print "      ,   ,   .^";
				else
					print "  ,    ,        .^";
				TryToDie();
		}
	],
  has scenery animate pluralname; ! general means in sight

Object FakeFrontier " "
  with
	description [;
		if (escaping)
			"  ,   ,   . []";
		print "     -  ;     .";
		if (loseguardseast.number > 0)
			print "     .";
		new_line;
		rtrue;
	],
	e_to [;
		print "  -      .       ,      .^";
		EndScene(1, 0);
		rtrue;
	],
	nw_to [;
		<<Go e_obj>>;
	],
	s_to [;
		print "   ,    .^";
		loseguardseast.shutdown();
		loneguard.startup();
		loseguardsnorth.startup();
		return FinalEnd;
	],
	cant_go "   -,     .";

Object -> fakeequipend "/ /"
  with
	name '' 's' '//' '' '' '' '',
	description "         .      .",
	react_before [;
		ThrowDir:
			if (second == s_obj)
				<<ThrowAt noun self>>;
	],
	before [;
		Examine: 
			rfalse;
		Enter:
			<<Go s_obj>>;
		ThrownAt:
			move noun to FinalEnd;
			print_ret (CCNom) noun, "   ", (V1bEnd) noun, "    .";
		default: 
			"   .";
	],
  has scenery male;

Object -> fakeequipdoor "/"
  with
	name 'door',
	description "     .",
	before [;
		Examine: 
			rfalse;
		ThrownAt:
			<<ThrowAt noun fakeequipend>>;
		default: 
			"    ,  .";
	],
  has scenery female;

Object FinalEnd ""
  with
	description [;
		print "    .   ";
		if (finaldoor hasnt open)
			print " ";
		else
			print " ";
		print "  .";
		new_line;
		if (loseguardsnorth in self && loseguardsnorth has general)
			print "^      .^";
		rtrue;
	],
	n_to [;
		if (escaping) {
			return SouthFrontier;
		}
		if (loseguardsnorth hasnt general)
			print "    ,       .  ,      ,        .^";
		else
			print "    . .^";
		if (parent(loneguard) == nothing)
			EndScene(1, 0);
		else
			TryToDie();
		rtrue;
	],
	w_to finaldoor,
	cant_go "     ,    .";
	
Object -> finalcabinet "/  "
  with
	name '' '' '',
	initial [;
		print "        . ";
		<Examine finaldrawer>;
		rtrue;
	],
	description [;
		print "        . ";
		<<Examine finaldrawer>>;
	],
	vehicle_name " (    )",
	ceiling_reachable true,
	react_before [;
		Exit:
			if (player in self) {
				move player to parent(self);
				if (keep_silent == 0)
					print "   ", (cGen) self, ".^";
				rtrue;
			}
		Go:
			if (player in self && noun == d_obj)
				<<Exit>>;
	],
	before [;
		Climb:
			<<Enter self>>;
		Take:
			if (player in self)
				<<Push self>>;
			"  ,   .";
		Push:
			if (player in self)
				"     .";
			"   ,      ,     .";
		Pull:
			if (player in self)
				<<Push self>>;
			"   ,      ,     .";
		Search:
			<<Search finaldrawer>>;
		Open, Close, Empty:
			<<(action) finaldrawer>>;
		Receive:
			if (receive_action == ##Insert)
				<<Insert noun finaldrawer>>;
		HideBehind:
			if (loneguard in FinalEnd && loneguard hasnt general) {
				rfalse; ! leave it to the loseguardsnorth
			}
			if (loseguardsnorth has general) {
				rfalse;
			}
			"    .";
	],
  has supporter static enterable male;

Object -> finaldrawer "/"
  with
	name '' '' '',
	description [;
		if (self hasnt open) {
			" .";
		}
		else {
			if (child(self) == 0)
				"   ,    .";
			print "   . ";
			<<Search self>>;
		}
	],
	before [;
		Take:
			if (self has open)
				<<Open self>>;
			print_ret "   ", (cGen) finalcabinet, ".";
		Pull:
			<<Open self>>;
		Push:
			<<Close self>>;
		Open:
			if (self has open)
				"    .";
	],
	after [;
		Open:
			if (self has general) {
				print "  . ";
				<<Search self>>;
			}
			give self general;
			"  ;    ,  , , .  .";
	],
  has scenery container openable ~open ~general male; ! general for open message

Object -> finaldoor "/ /"
  class InteriorDoor,
  with
	name '//' '' '',
	description [;
		print "  ,    ,         . ";
		if (self hasnt open)
			" .";
		else
			" ,      ,      .";
	],
	door_dir w_to,
	door_try [; 
		if (self has open)
			" -    .";
		PronounNotice(self);
		print_ret (CCNom) self, "   ."; 
	],
	before [;
		ActivateTool:
			"^ ,   --  . []";
	],
  has female;

Object -> finaldoorplate "/ /  "
  class InteriorPlate,
  with
	work_target finaldoor;

Object -> hypervent "/ "
  with
    name '' '' '' '' '' '',
	!parse_name [ num wd;
	!	num = 0;
	!	wd = NextWord();
	!	while ((WordInProperty(wd, ventilator, name) ~= 0)) {
	!		num++;
	!		wd = NextWord();
	!	} 
	!	return num;
	!],
	description [;
		if (self hasnt open)
			<<Examine ventilator>>;
		print "  ,   ,   .  ";
		if (player notin finalcabinet)
			",        ,  .";
		if (child(self)) {
			print ".       ";
			WriteListFrom(child(self), TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
			".";
		}
		else {
			";     .";
		}
	],
	before [;
		Examine:
			rfalse;
		Search:
			if (self hasnt open)
				<<Search ventilator>>;
			if (player notin finalcabinet)
				"       .";
			if (child(self)) {
				print "    ";
				WriteListFrom(child(self), TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
				".";
			}
			else {
				" , , .";
			}
		Enter:
			if (player notin finalcabinet)
				<<Touch ventilator>>;
			"    30  .";
		EmptyT:
			if (player notin finalcabinet)
				<<Touch ventilator>>;
			"       .";
		Empty:
			if (player notin finalcabinet)
				<<Touch ventilator>>;
			if (self hasnt open)
				rfalse;
			if (child(self) == nothing)
				"      .";
		Open:
			if (self has open)
				print_ret (CCNom) self, "  .";
			if (player notin finalcabinet)
				<<Touch ventilator>>;
			give self open;
			give self general;
			print "   .^";
			if (child(self)) {
				print "^  ";
				WriteListFrom(child(self), TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
				print ".^";
			}
			rtrue;
		Close:
			if (self hasnt open)
				print_ret (CCNom) self, "  .";
			if (player notin finalcabinet)
				<<Touch ventilator>>;
			give self ~open;
			"  .";
		Listen:
			<<Listen ventilator>>;
		ThrownAt:
			rfalse;
		default: ! including LetGo
			if (player notin finalcabinet)
				<<Touch ventilator>>;
			rfalse;
	],
  has scenery container ~open ~general female; 
	! general means you've done something suspicious with it.

Object loneguard "/"
  with
	!name '' '' '' '' '',
	parse_name [ n;
		n = 0;
		while (NextWord() == '' or '' or '' or '' or '' or '' or '') n++;
		return n;
	],
	describe [;
		if (self hasnt general) {
			if (self.number == 2)
				"^        .     .";
			else 
				"^  ,     .";
		}
		else {
			"^     .";
		}
	],
	description [;
		if (self hasnt general) {
			print " ,    .       .   ,       ,         .^";
		}
		else {
			print " ,    .      ,   .";
			if (loneguardgun in parent(self))
				print "      .";
			new_line;
		}
		rtrue;
	],
	before [;
		ActivateTool:
			if (player in finalcabinet) {
				keep_silent = 1;
				<Exit>;
				keep_silent = 0;
				print "   ,            .";
			}
			else {
				print "           .";
			}
			print "        .^^   ,      .^";
			StopDaemon(self);
			give self general;
			move loneguardgun to parent(self);
			move self to parent(self); ! to get order right
			rtrue;
		Search:
			if (self hasnt general)
				"      .";
			"   ,    .        .";
		Push, Pull:
			if (self hasnt general)
				<<Attack self>>;
			"   .";
		Take:
			if (self hasnt general)
				",  ,     .";
			".";
	],
	life [;
		Attack:
			if (self hasnt general) {
				if (player in finalcabinet) {
					keep_silent = 1;
					<Exit>;
					keep_silent = 0;
					print "          .^";
				}
				else {
					switch (random(3)) {
						1: print "       .^";
						2: print "   ,     .^";
						default: print "  ,    .^";
					}
				}
				self.number = 10;
				rtrue;
			}
			else {
				"    --     .";
			}
		ShootAttack:
			"    --     .";
		Ask, Tell, AskFor, Answer:
			if (self hasnt general)
				"  .";
			else
				"   .";
		Show, Give:
			if (self hasnt general)
				"  .";
			else
				"   .";
		Kiss:
			#ifdef ZDEBUG;
			self.number = 20;
			",   . []";
			#ifnot;
			"  .";
			#endif; ! ZDEBUG;
	],
	orders [;
		if (self hasnt general)
			"  .";
		else
			"   .";
	],
	startup [;
		remove self;
		self.number = 0;
		give self ~general;
		move loneguardgun to self;
		give loneguardgun ~moved;
		move loneguarduniform to self;
		StartDaemon(self);
	],
	shutdown [;
		StopDaemon(self);
		remove self;
		remove loneguardgun;
	],
	number 0,
	daemon [;
		if (location ~= FinalEnd) {
			self.shutdown();
			"-    @<<  @>>. []";
		}
		self.number++;
		switch (self.number) {
			! 1: do nothing
			2: 
				give finaldoor open;
				move self to FinalEnd;
				PronounNotice(self);
				print "^  ,        . @<<,   ",
					(emphstring) "", " ,   ,      ,     ,    @>>, --   -,  .^^   .       .^";
			3:
				if (self hasnt general)
					print "^     .^";
			4:
				print "^        .   ,    .^";
				EndScene(2);
				rtrue;
			11:
				switch (random(3)) {
					1: print "^          .^";
					2: print "^  ,       .^";
					default: print "^      .^";
				}
			12:
				print "^    .   ,    .^";
				EndScene(2);
				rtrue;
		}
	],
  has static animate transparent ~general male; ! general means unconscious

Object loneguardgun "/ "
  class PulseGun,
  with
	short_name " ",
	name '',
	!article "the",
	initial "     .",
	description [;
		print "   ,   .  , ,           .     .";
		if (self in loneguard) {
			if (loneguard.number == 2)
				"      .";
			else
				"     .";
		}
		new_line;
		rtrue;
	],
	before [;
		Take:
			if (self in loneguard) {
				"    ,      .";
			}
		Attack:
			if (self in loneguard) {
				"     ,      ,     .";
			}
	],
  has male;

Object loneguarduniform "/ "
  with
	name '' '',
	description "       .",
	before [;
		Take:
			if (loneguard hasnt general)
				" ,    .";
			else
				"   .      .";
		Search:
			<<Search loneguard>>;
	],
  has scenery female;

[ TryToDie   ix jx;

	print "^^    ";
	print (boldstring) "***   ***";
	print "^^";

	DumbGlobalGuardOut = (loneguard has general);
	
	! if attention is drawn to the vent *at all* -- like if the
	!   vent has been opened -- we proceed immediately to the escape
	!   sequence, regardless of what else has occurred. This is checked
	!   in end_scene().

	ix = LeftToolsBehind(6, player);
	if (ix == 0) {
		! still holding everything
		EndScene(3);
		rtrue;
	}
	
	jx = LeftToolsBehind(6, finaldrawer);
	if (jx == 0) {
		! hid everything in finaldrawer... unless it's open.
		EndScene(4, finaldrawer has open);
		rtrue;
	}
	
	! otherwise, there is stuff just scattered around. 
	! (But nothing in the vent.)
	EndScene(5, children(finaldrawer));
	rtrue;
];
