
! We have three basic phases here. First, you leave the interrog room, but
! you can't go west of NortheastCorner / TossJunction. Then you blow the
! lights, and the guards chase you to where the gun is. Then you have
! the gun, shoot the guards; but two more groups of guards begin circling
! to cut you off. They converge at the lab junction.

Object sc_7
  class Scene,
  with
	number 7,
	init_scene [;
		SetQuestion(q7_1);
	],
	begin_scene [;
		BeginGreatEscape();
	],
	end_scene [;
		"      . []";
	];

Object q7_1
  class Question,
  with
	query [;
		new_line;
		print "  ,     . @<< .  ", (emphstring) "", "@>>.^^";
		print "   - ,      . @<< ?@>> --    . @<<  ,     --@>>    . @<<,  ,  .  - .    ";
		ventilator.number(FinalEnd);
		print "   .        ,   .   @>>.     .^^";
		print "   . @<<, ,   @>>, --   .^";
	],
	time_limit 1,
	answer_yes [;
		print "  . @<<, ";
		SetQuestion(q7_2);
	],
	answer_no [;
		print " . @<<   . , ";
		SetQuestion(q7_2);
	],
	answer_wait [;
		print " : @<<   . ";
		SetQuestion(q7_2);
	];

Object q7_2
  class Question,
  with
	query [;
		print "    --   ,       .  ,     ,       ,           .      ,    -  .     ,     ", (emphstring) "", "@>>.^";
		print "^  . @<<    ,  ?@>>^";
	],
	time_limit 1,
	! swapped yes/no -- y4n
	answer_no [;
		print "@<<?  , .";
		SetQuestion(q7_3);
	],
	answer_yes [;
		print "@<<.";
		SetQuestion(q7_3);
	],
	answer_wait [;
		print "@<< .";
		SetQuestion(q7_3);
	];

Object q7_3
  class Question,
  with
	query [;
		print "   ,     ,      .        .  -  --@>>^^    .   ,  . @<<  .    @>>.^";
	],
	time_limit 1,
	answer_yes [;
		print "   ,   .^";
		SetQuestion(q7_4);
	],
	answer_no [;
		print "   ,   .^";
		SetQuestion(q7_4);
	],
	answer_wait [;
		print " .^";
		SetQuestion(q7_4);
	];

Object q7_4
  class Question,
  with
	query [;
		print "^ .           .^^";
		print "   .   ,  ,   .   ,       .^^";
		move toolitems to interrogdesk;
		print " ,    ,    . @<< ?   ?@>>^^@<<?@>> --   .^^@<<. @>>.     ,         . @<<.      ,   ", (emphstring) "", "  .  ", (emphstring) "", "@>>.^";
	],
	time_limit 6,
	daemon [;
		switch (self.number) {
			2: "^@<<   ,    @>>.";
			4: "^    ,    .";
			5: "^@<<,  !@>>";
		}
	],
	answer_general "     @>>, --   .      .",
	answer_yes [;
		print "@<<  ,   ";
		self.answer_general();
		BrainDrain();
		rtrue;
	],
	answer_no [;
		print "@<<  ,   ";
		self.answer_general();
		BrainDrain();
		rtrue;
	],
	answer_wait [;
		print "@<<.   ";
		self.answer_general();
		SetQuestion(q7_fake);
		BrainDrain();
	];

Object q7_fake
  class Question,
  with
	query [; rtrue; ];

Object toolitems "/"
  with
	article "",
	name '' '' '' '' ''
		'' '' '' '' '' ''
		'' '' '' '' '' '' '',
	description [;
		print "       .  ";
			ColorTarget (minilight);
            print "   ";
			ColorTarget (scrambler); 
            print " .   : ,   .  ";
			ColorTarget (blasttab);
            print "     ";
			ColorTarget (acidpack);
            "   .  .   ,  ,   .";
	],
	react_before [ ix;
		Tango:
			<<ActivateTool self>>;
		Waltz:
			<<DeactivateTool self>>;
		VagueSay, Answer:
			if (consult_words >= 1) {
				wn = consult_from;
				ix = NextWord();
				if (ix == '~//' && consult_words >= 2) {
					ix = NextWord();
				}
				if (ix == '') {
					<<ActivateTool self>>;
				}
				if (ix == '') {
					<<DeactivateTool self>>;
				}
			}
	],
	before [;
		ActivateTool: 
			print "   .     ,     ;    .^^";
			print "- ,    ,   .      .  ,       .   ...  ...^^     .^";
			BeginScene(1000);
			rtrue;
		DeactivateTool:
			print "   ,    . ", (CCNom) voicetrans,
				", ,    .^";
			print "^    ,     .         . ,  ,     .^";
			BrainDrain();
			rtrue;
	],
	orders [;
		Tango:
			<<ActivateTool self>>;
		Waltz:
			<<DeactivateTool self>>;
		default:
			" .";
	],
  has scenery pluralname talkable;

[ BeginGreatEscape;
	if (escaping)
		"?   ! []";
	
	escaping = 1;
	move activeplayer to InterrogRoomReal;

	move boltwrench to largecrate; ! back where it started
	give cornerdoor ~open; ! wrench storageroom
	give panelhole general; ! existence of blood 
	move blood to CeilingHole;
	remove package;
	remove equiptalker;
	remove tossguards;
	give tossguards absent;
	tossguards.work_target = 0;
	remove baitguards;
	remove dooropenguards;
	remove bigguards;
	OfficeSketchStartup(); ! all in SecurityOffice, with static
	give finaldrawer ~open;
	while (child(finaldrawer)) {
		remove child(finaldrawer);
	}
	give finaldoor ~open;
	give hypervent ~open;
	while (child(hypervent)) {
		remove child(hypervent);
	}
	remove loneguard;
	remove loneguardgun;

	give cornermetaldoor ~open;
	give tossmetaldoor ~open;
	give deadendmetaldoor ~open;
	give secbranchdoor ~open;
	give finaldoor ~open;
	
	! ok, we can begin assembly now.
	
	remove interrealchair;
	remove interrealleads;
	remove interrealbands;
	move brokenchair to InterrogRoomReal;
	move brokenvoicemod to InterrogRoomReal;
	StartDaemon(brokenchair);
	move HimselfEscape to InterrogRoomReal;
	move himselfescapeuniform to InterrogRoomReal;
	
	move penstain to poisonpen;
	remove pennib;
	if (poisonpen_model in Himself)
		move poisonpen to interrealdesk;
	else
		move poisonpen to HimselfEscape;
	
	EscapeToolPositions(interrealdesk);
	
	StartDaemon(HimselfEscape);
	PronounNotice(HimselfEscape);
];

Object brokenchair "/ "
  with
	name '' '' '' '' '' '',
	initial "     ,  - ,    .",
	description "      --  ,   ,    .         .",
	before [;
		Take, Search, Push, Pull, Touch:
			" ,      .";
		Smell:
			"   .";
		Enter:
			" ,    ,    ,   .";
	],
	number 0, ! for daemon
	number2 0, ! true if scrambler-alarm occured
	daemon_priority -10, ! after the timer, and pretty much everything else.
	daemon [;
		if (powercut == 0) { ! after cut, no scanning
			if (scrambler has general && self.number2 == 0) {
				self.number2 = 1;
				if (anywherein(scrambler, location))
					print "^     ,    ,     . ,     .^";
				else
					print "^      .^";
				SummonEsguardsSecurity();
			}
		}
		
		self.number++;
		switch (self.number) {
			5, 7:
				if (location == parent(self))
					print "^,    ,  .^";
			8:
				if (location == parent(self))
					print "^      .^";
				remove self;
			25:
				if (powercut)
					return;
				if (SummonEsguardsSecurity()) {
					if (location == InterrogRoomReal)
						print "^     .     .         .^";
					else
						print "^    .  .^";
				}
			6:
				print "^    .^";
			10:
				print "^     .^";
			14, 20:
				print "^  .^";
			40:
				print "^  - ,   -.^";
		}
	],
  has static pluralname;

Object brokenvoicemod "/ /"
  with
	name '' '' '' '' '' '',
	description "     .",
	before [;
		Take:
			"    .";
		Push, Pull, Turn, Attack:
			"    .";
		TouchTo, TouchFrom:
			"    .";
	],
  has scenery connector male;

Constant HimselfEscapeNoTalk 
	"   ,     .";

Object HimselfEscape "//"
  with
	name '' '' '' '' '' '' '',
	initial [;
		if (self hasnt general) {
			switch (self.number) {
				0, 1: 
					"    ,  -  ,   .";
				100, 101:
					"     . ,   .      .";
				default:
					"   .";
			}
		}
		else {
			"    ,  .     .";
		}
	],
	description [;
		if (self hasnt general) {
			self.initial();
		}
		else {
			" -   .";
		}
	],
	before [;
		Search:
			if (self hasnt general)
				".";
			if (child(self) == nothing) {
				print "     ,    .";
			}
			else {
				print "     ;  ";
                if (children(self) > 1)
					print " ";
				else
					print " ";
				print " ";
				WriteListFrom(child(self), TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
				print ".";
				while (child(self)) {
					move (child(self)) to parent(self);
				}
			}
			if (self.number2 == 0) {
				self.number2 = 1;
				print " ,    ,       .  --  --   ,     .   .";
			}
			new_line;
			rtrue;
		Push, Pull:
			if (self hasnt general)
				<<Attack self>>;
			"   .";
		Take:
			if (self hasnt general)
				"  .";
			"      ,     .      .";
	],
	number2 0, ! true if searched already
	life [;
		Attack:
			if (self has general)
				"    ,    .";
			give self general;
			StopDaemon(self);
			"      ,      .   ,   -,       .  ,          .     ,   .";
		Ask, Tell, AskFor, Answer:
			if (self hasnt general)
				print_ret (string) HimselfEscapeNoTalk;
			else
				"   .";
		Show, Give:
			if (self hasnt general)
				print_ret (string) HimselfEscapeNoTalk;
			else
				"   .";
	],
	orders [;
		if (self hasnt general)
			print_ret (string) HimselfEscapeNoTalk;
		else
			"   .";
	],
	number 0, ! for daemon
	daemon_priority 3,
	daemon [;
		if (self has general) {
			StopDaemon(self);
			"    . []";
		}
		if (location ~= parent(self)) {
			self.number = 100;
			return;
		}
		self.number++;
		switch (self.number) {
			2: 
				print "^, ,     .          .^";
			3:
				print "^   ,       .^";
			4:
				print "^       .   -- -      ;    ,   -  .       ,            ,   .^";
				deadflag = 3;
			101:
				print "^ . @<< @>>, --      .^";
				deadflag = 3;
		}
	],
  has static animate ~general female; ! general means unconscious ! -- female for case purposes [y4n]

Object himselfescapeuniform "/ /"
  with
	name '' '' '' '',
	description [;
		if (HimselfEscape hasnt general)
			print "  .";
		else
			print "  ,       .";
		"  ,       ,   .";
	],
	before [;
		Search:
			<<Search HimselfEscape>>;
		Take:
			if (HimselfEscape hasnt general)
				"  .";
			" ,        .         ,   ,     .";
	],
  has scenery female;

! Returns true if they actually started. This is silent, at least when not fast.
[ SummonEsguardsSecurity fast;
	if (esguardssec.number)
		return false; ! don't summon twice
	esguardssec.startup(fast);
	return true;
];

Object esguardssec "/"
  with
	name '' '' '',
	number 0,
	startup [ fast;
		self.number = 1;
		if (fast)
			self.number = 2;
		StartDaemon(self);
		! due to annoying circumstances, not worth the time to fix, these
		! guys are delayed one turn if summoned by the scrambler.
	],
	shutdown [;
		StopDaemon(self);
		remove self;
		self.number = 99;
	],
	daemon_priority 4, ! fast buggers
	daemon [ oldloc loc;
		self.number++;
		if (self.number <= 2)
			return;
		oldloc = parent(self);
		if (location == oldloc) {
			deadflag = 3;
			"^, , ,     .    ,        - ,  ,   ,    .";
		}
		switch (self.number) {
			! 0, 1, 2: Do nothing -- already returned
			3:
				move self to SecurityBranch;
			4:
				if (location == LabJunction or NortheastCorner)
					move self to NortheastCorner;
				else if (location == TossJunction or SouthFrontier
					or DeadEndHall or WiringCloset)
					move self to TossJunction;
				else
					move self to SecurityAnnex;
			5:
				if (location == WiringCloset)
					move self to DeadEndHall;
				else
					move self to location;
			default:
				move self to location;
		}
		loc = parent(self);
		switch (loc) {
			InterrogRoomReal, SecurityOffice, SecurityStorage:
				if (location == loc) {
					deadflag = 3;
					"^      .      ,     ,      .";
				}
			WiringCloset:
				if (location == loc) {
					deadflag = 3;
					new_line;
					if (deadendmetaldoor has open)
						print "      ";
					else
						print " ,      ";
					".      ,     ,      .";
				}
			SecurityBranch:
				if (location == SecurityBranch or NortheastCorner 
					or TossJunction or SecurityAnnex) {
					deadflag = 3;
					if (oldloc == nothing) {
						print "^";
						switch (location) {
							NortheastCorner: print "  ,  ,";
							TossJunction: print "  ,  ,";
							SecurityAnnex: print "   ,  -,";
						}
						" .            .  ,    .";
					}
					else {
						"^       .     ,    .";
					}
				}
			TossJunction:
				if (location == SecurityBranch or NortheastCorner 
					or TossJunction or DeadEndHall or SouthFrontier) {
					deadflag = 3;
					print "^     ";
					switch (location) {
						DeadEndHall: print "  ";
						SouthFrontier: print "  ";
					}
					".        .";
				}
			NortheastCorner:
				if (location == SecurityBranch or NortheastCorner 
					or TossJunction or LabJunction) {
					deadflag = 3;
					print "^     ";
					switch (location) {
						LabJunction: print "  ";
					}
					".        .";
				}
			default:
				if (location == loc) {
					deadflag = 3;
					"^        .      ,     ,      .";
				}
		}
	],
  has animate pluralname scenery;

Object NortheastCorner "- "
  with
	description [;
		print "         .     , ";
		if (necornerdoor hasnt open)
			" .";
		else
			" .";
	],
	s_to SecurityBranch,
	n_to necornerdoor,
	w_to [;
		if (escaping) {
			if (powercut == 0) {
				"    ,     ,   . ,   ,   , -   .     .     ,  ,   ,   .";
			}
		}
		return LabJunction;
	];

Object -> necornerdoor "/ /"
  class InteriorDoor,
  with
	name '//' '' '',
	description [;
		print "   ,         .";
		if (self has open)
			"  .";
		else
			"  .";
	],
	door_dir n_to,
	before [;
		ActivateTool:
			if (escaping) {
				if (location == NortheastCorner) {
					print "^ .      ,    .        .^^     ,      .^";
				}
				else if (location == SecurityBranch or TossJunction or
					LabJunction) {
					print "^";
					switch (location) {
						SecurityBranch: print "  ";
						TossJunction: print "    ,  ,";
						LabJunction: print "  ";
					}
					print "     . -, ,    .^^-, ,     ,      .^";
				}
				else {
					print "^-    .^";
				}
				SummonEsguardsSecurity();
				rtrue;
			}
	],
  has female;

Object -> necornerdoorplate "/ /  "
  class InteriorPlate,
  with
	work_target necornerdoor;

Object SharpCorner " "
  with
	description [;
		print "    ,  -  .  ,  ,    , ";
		if (sharpcornerdoor hasnt open)
			" .";
		else
			" .";
	],
	nw_to NorthBoundary,
	n_to LabJunction;

Object -> sharpcornerdoor "/ /"
  class InteriorDoor,
  with
	name '//' '' '',
	description [;
		print "   ,         .";
		if (self has open)
			"  .";
		else
			"  .";
	],
	door_dir s_to,
    has female;

Object -> sharpcornerdoorplate "/ /  "
  class InteriorPlate,
  with
	work_target sharpcornerdoor;

Object WiringCloset ""
  with
	description [;
		print "  ,      .      , ,   .   --";
		if (deadendmetaldoor has open) {
			if (deadendmetaldoor.number2)
				print " ";
			else
				print " ";
		}
		else
			print " ";
		print "   ,      .";
		new_line;
		if (powernode in self && child(powernode)) {
			print "^     ";
            if (children(powernode) > 1)
                print "";
            else
                print "";
			print " ";
			WriteListFrom(child(powernode),
				TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
			print ".^";
		}
		if (powernodebroke in self)
			print "^    .^";
		rtrue;
	],
	out_to wiringdoorin,
	s_to wiringdoorin;

Object -> powercables "//  /"
  with
	name '' '' '' '' '',
	description "     ;    ,       .",
	before [;
		Take, Push, Pull, Turn:
			"    .";
		Attack:
			"   ,    .";
		Climb:
			"       ,     .    .";
	],
  has scenery pluralname;

Object -> powernode "/ /"
  with
	name '' '' '',
	description [;
		print "    ,       .";
		if (child(self)) {
			print " ";
			<Search self>;
		}
		else {
			new_line;
		}
		rtrue;
	],
	before [;
		Search:
			if (child(self) == nothing) 
				"    .";
			print "   ";
            if (children(self) > 1)
                print "";
            else
                print "";
			WriteListFrom(child(self),
				TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
			".";
		Receive:
			if (receive_action == ##PutOn)
				<<Insert noun self>>;
		Attack, Push, Pull, Turn:
			"     .";
		Open, Close:
			"  .";
	],
	after [ ix;
		Receive:
			ix = child(self);
			if (ix == noun)
				ix = sibling(ix);
			print "  ", (cAcc) noun, " ";
			if (ix == nothing)
				"    .";
			if (sibling(ix))
				" ,   ,    .";
			print_ret " ,   ", (cIns) ix, ".";
	],
  has scenery open container male; 

Object -> wiringdoorin "/ /"
  with
	name '' '',
	description [;
		print "   ,   . , ,   . ";
		if (deadendmetaldoor has open)
			" .";
		else
			" .";
	],
	door_dir s_to,
	door_to DeadEndHall,
	door_try [;
		if (deadendmetaldoor hasnt open) {
			PronounNotice(self);
			"  .";
		}
	],
	before [;
		Open:
			if (deadendmetaldoor hasnt open)
				"    .";
		Close:
			if (deadendmetaldoor hasnt open)
				"  .";
			else
				"  , .";
		Push, Turn: 
			"  .";
		Touch, Rub: 
			"     .";
	],
  has scenery door open female;

Object -> wiringclosetpad
  class ContactPad,
  with
	before [;
		Touch:
			if (powercut) {
				print "  .";
				if (deadendmetaldoor hasnt open) {
					deadflag = 3;
					print "        -- ,     .^^    .      ,  ,  .";
				}
				new_line;
				rtrue;
			}
			if (deadendmetaldoor has open) {
				give deadendmetaldoor ~open;
				", , .";
			}
			else {
				give deadendmetaldoor open;
				"  .";
			}
	],
	is_active [ noisy;
		if (noisy == 0) {
			if (powercut)
				rfalse;
			else
				rtrue;
		}
		else {
			<<Touch self>>;
		}
	];

Object powernodebroke "/ /"
  with
	name '' '' '' '',
	description "     .",
	before [;
		Search:
			"     .";
		Touch, Attack, Push, Pull:
			",   .";
		Receive:
			"      .";
	],
  has scenery male;


