
[ CutOffPower   gotlamp;
	if (powercut)
		"   . []";
	powercut = 1;
	print_player_flag = 1;
	
	gotlamp = 0;
	if ((minilight has general) && TestScope(minilight))
		gotlamp = 1;
	
	print "^ ,";
	if (gotlamp == 0)
		print "    ,  ";
	else
		print "    ,  ,     ";
	print ".^^";
	
	print (boldstring) " ", "^^";
	
	print "       ,       .    ,        .   .  ,            .^";
	
	remove powernode;
	move powernodebroke to WiringCloset;
	
	esguardssec.shutdown();
	remove HimselfEscape;
	
	StopDaemon(deadendmetaldoor);
	deadendmetaldoor.number2 = 0;
	
	! begin new stuff
	
	dimguards.startup();
	sharpguards.startup();
	
	<Look>;
];

Constant DimPathLength 10;

Array dimpath --> SecurityBranch TossJunction SouthFrontier
	SouthBoundary WhiteJunction CeilingHole NorthBoundary SharpCorner
	LabJunction NortheastCorner;
Array dimpathdir --> s_to s_to w_to nw_to w_to n_to e_to se_to n_to e_to;

[ OppositeDir dir;
	switch (dir) {
		n_to: return s_to;
		ne_to: return sw_to;
		e_to: return w_to;
		se_to: return nw_to;
		s_to: return n_to;
		sw_to: return ne_to;
		w_to: return e_to;
		nw_to: return se_to;
		default: return dir;
	}
];

[ DirWordTrio dir;
	switch (dir) {
		n_to: return dirwordlist + 0;
		ne_to: return dirwordlist + 6;
		e_to: return dirwordlist + 12;
		se_to: return dirwordlist + 18;
		s_to: return dirwordlist + 24;
		sw_to: return dirwordlist + 30;
		w_to: return dirwordlist + 36;
		nw_to: return dirwordlist + 42;
		default: return dirwordlist + 48;
	}
];

Array dirwordlist -->
	'//' '' ''
	'' '-' '-'
	'//' '' ''
	'' '-' '-'
	'//' '' ''
	'' '-' '-'
	'//' '' ''
	'' '-' '-'
	'none,' 'none,' 'none,' 'none,';

! this is really the sound of the guards; the guards themselves are
! one step behind.
Object dimguards "/"
  with
	name '' '' '' '' '' '',
	parse_name [ num wd ptr;
		ptr = DirWordTrio(OppositeDir(dimpathdir-->(self.number2)));
		num = 0;
		wd = NextWord();
		while ((WordInProperty(wd, dimguards, name) ~= 0)
			|| wd == (ptr-->0) or (ptr-->1) or (ptr-->2)) {
			num++;
			wd = NextWord();
		} 
		return num;
	],
	short_name [;
		print "  ";
		print (cPre) OppositeDir(dimpathdir-->(self.number2));
		rtrue;
	],
	describe [;
		if (self hasnt general) {
			print "^ ,     ,  ";
			print (cPre) OppositeDir(dimpathdir-->(self.number2));
			print ". ,     ,    ,  .^";
			give self general;
		}
		else {
			print "^ ";
			if (self.agitated)
				print " ";
			print "     ,  ";
			print (cPre) OppositeDir(dimpathdir-->(self.number2));
			print ".^";
		}
		rtrue;
	],
	description [;
		print "        ";
		print (cPre) OppositeDir(dimpathdir-->(self.number2));
		". ,   .";
	],
	react_before [;
		Listen:
			if (noun == nothing) {
				if (sharpguards in location && sharpguards.number >= 0)
					rfalse;
				<<Listen self>>;
			}
	],
	before [;
		Examine:
			rfalse;
		Listen:
			if (self.agitated == 0)
				print "   ";
			else
				print "      ";
			print_ret "  ",
				(cPre) OppositeDir(dimpathdir-->(self.number2)),
				".";
		ShootAttack:
			rfalse;
		AttackWith:
			if (second ofclass PulseGun)
				rfalse;
			<<Touch self>>;
		ThrownAt:
			"      .";
		default:
			print_ret "    ",
				(cPre) OppositeDir(dimpathdir-->(self.number2)),
				".";
	],
	life [;
		Kiss:
			"  .";
		Ask, Tell, AskFor, Answer:
			"  .";
		ShootAttack:
			gun.answer_general();
			self.here_counter = 0; ! they hesitate one move
			if (self.agitated == 0) {
				self.agitated = 2;
				sharpguards.agitated(1);
				"       ,   ,   ,  .   ,     -.";
			}
			else {
				self.agitated = 2;
				"     ,   .";
			}
	],
	orders [;
		"  .";
	],
	startup [;
		self.number = 0;
		self.number2 = 9;
		move self to (dimpath-->(self.number2));
		self.work_target = 0;
		self.here_counter = 0;
		StartDaemon(self);
	],
	shutdown [;
		StopDaemon(self);
		remove self;
	],
	number 0, ! counter
	number2 0, ! index in dimpath
	agitated 0, ! are they running?
	work_target 0, ! where the guards are physically
	here_counter 0, ! how many turns has (self in location) been true?
	num_missed 0, ! how long have you spent in a stand-off?
	daemon [ ix;
		! fixed parties
		switch (location) {
			SecurityAnnex:
				deadflag = 3;
				"^       :   ,   ;    ,   .       .         ,      ,  .";
			InsideEntrance:
				deadflag = 3;
				"^        .   ,    ,    .      .";
			SharpCorner:
				! this is abuse of the terminology, but it works
				sharpguardshere.daemon();
				if (deadflag)
					return;
			LabJunction:
				if (sharpguardshere.number ~= 2) {
					sharpguardshere.number = 2;
					if (sharpguards.number >= 0) {
						print "^   ,   .^";
						! but you don't die. The guards get "knocked out"
						! really because any active members get merged with
						! dimguards.
						sharpguards.agitated(-1); 
						! dimguards jump ahead, if they're not already
						if (self.number2 > 0 && self.number2 < 7) {
							self.number2 = 7;
							move self to SharpCorner;
							self.work_target = NorthBoundary;
						}
					}
				}
			NortheastCorner:
				deadflag = 3;
				"^     ,     ,      .  ,    .     .";
		}
		! moving party
		if (self.work_target ~= 0 && location == self.work_target) {
			deadflag = 3;
			if (self.agitated)
				print_ret "^   ",
					(cAcc) OppositeDir(dimpathdir-->(self.number2)),
					",    .    ,    ,     .";
			print_ret "^      ",
				(cPre) dimpathdir-->(self.number2),
				"   .     , ,  ,   ,    .";
		}
		self.number++;
		if (self.agitated) {
			! the shooting has started! Run now.
			self.number = 4;
		}
		if (self.number >= 3 && self in location && self.here_counter == 0) {
			self.number = 2; ! hack so we don't walk in on guards unexpectedly.
			! note that this is always followed by here_counter++.
		}
		if (self.number >= 3) {
			self.number = 0;
			ix = dimpathdir-->(self.number2);
			self.work_target = parent(self);
			self.number2++;
			if (self.number2 >= DimPathLength)
				self.number2 = 0;
			move self to (dimpath-->(self.number2));
			self.here_counter = 0;
			if (self.work_target ~= 0 && location == self.work_target) {
				deadflag = 3;
				if (self.agitated)
					print_ret "^   ,   ",
						(cGen) OppositeDir(ix),
						": @<< !@>>       ,       .";
				if (player in panelhole)
					print_ret "^,   ",
						(cGen) OppositeDir(ix),
						",     .   ,        ,      ,   ,   . , ,       .";
				print_ret "^,   ",
					(cGen) OppositeDir(ix),
					",     .     , ,  ,   ,    .";
			}
			if (self in location) {
				if (self hasnt general) {
					print "^ ,       ";
					print (cPre) OppositeDir(dimpathdir-->(self.number2));
					print ". ,     ,    ,  .^";
					give self general;
				}
				else {
					print "^       ";
					print (cPre) OppositeDir(dimpathdir-->(self.number2));
					print ".^";
				}
			}
			! special cases
			switch (self.work_target) {
				TossJunction:
					if (location == DeadEndHall) {
						deadflag = 3;
						print "^      .    ,           .   ,   - .^";
					}
					if (location == WiringCloset && deadendmetaldoor has open) {
						deadflag = 3;
						print "^      --       . ,   ,   ,    ,   - .^";
					}
				SouthFrontier:
					if (location == FinalEnd) {
						deadflag = 3;
						print "^      .    ,           .      .^";
					}
				CeilingHole:
					if (location == StorageCloset) {
						deadflag = 3;
						if (cornerdoor has open)
							print "^     ";
						else
							print "^ ,       .";
						print "            .^";
					}
			}
		}
		else {
			if (self in location) {
				self.here_counter++;
				print "^   ";	
				print (cPre) OppositeDir(dimpathdir-->(self.number2));
				if (self.agitated) {
					! self.number always is 2
					if (self.agitated > 1) {
						self.agitated = 1;
						self.num_missed++;
						print "  .";
					}
					else {
						print "  .";
					}
					if (self.num_missed >= 8) {
						deadflag = 3;
						if (player in panelhole)
							print "  ";
						else
							print "  ";
						"  ,       .";
					}
					switch (random(3)) {
						1: "    ,    .    .";
						default: 
							print "    ,   ";
							if (player in panelhole)
								"  .";
							else
								".";
					}
				}
				! else...
				! print " are";
				if (self.number < 2)
					print " .^";
				else
					print "   .      .^";
			}
			else {
				self.here_counter = 0;
			}
		}
	],
  has animate pluralname static; ! general means heard once

Object sharpguards "/  -"
  with
	name '' '' '' '' '-' '-' '-' '-'
		'' '' '' '' '',
    parse_name [ num wd;
		num = 0;
		wd = NextWord();
		while (WordInProperty(wd, sharpguards, name) ~= 0) {
			num++;
			wd = NextWord();
		} 
		return num;
	],
	describe [;
		switch (self.number) {
			0:
				if (self hasnt general) {
					print "^    --   - . ,  ,    .            . ,     ,         .^";
					give self general;
				}
				else {
					print "^ -   .^";
				}
			1:
				if (self hasnt general) {
					print "^       ,    .   - ,  ,     .^";
					give self general;
				}
				else {
					print "^       -.^";
				}
			-1:
				print "^ -   ,   .^";
			default:
				print "^       -.^";
		}
		rtrue;
	],
	description [;
		! you can get off five shots, but you die on the fifth.
		switch (self.number) {
			0: " --    .";
			1: "       .";
			2: "  -      .";
			3, 4: "   ,   .";
			-1: "   -      .     .";
			default: "  . []";
		}
	],
	react_before [;
		Listen:
			if (noun == nothing) {
				if (self.number < 0) {
					rfalse;
				}
				if (dimguards in location)
					print_ret "   ,   ,   - -- .";
				<<Listen self>>;
			}
	],
	before [;
		Examine:
			rfalse;
		Listen:
			switch (self.number) {
				-1: rfalse;
				0: "    -      .";
				default: "     .";
			}
		ShootAttack:
			rfalse;
		AttackWith:
			if (second ofclass PulseGun)
				rfalse;
			<<Touch self>>;
		ThrownAt:
			if (self.number) {
				"  ."; ! do better?
			}
			"      .";
		default:
			print_ret "   -.";
	],
	life [;
		Kiss:
			"  .";
		Ask, Tell, AskFor, Answer:
			self.orders();
			rtrue;
		ShootAttack:
			gun.answer_general();
			dimguards.agitated = 1;
			switch (self.number) {
				0:
					self.agitated(2);
					" ,     .  ,     ,    .   , ,   .       ,   ,   .";
				1:
					self.number = 2;
					"           .       -   .";
				2:
					self.number = 3;
					"      ,         - .";
				3:
					self.number = 4;
					"   ,        .";
				4:
					self.agitated(-1);
					"  -   , ,  .     -  ,   .";
				-1:
					"  ,        .";
				default:
					".   . []";
			}
	],
	orders [;
		"  .";
	],
	startup [;
		self.number = 0;
		move self to NorthBoundary;
		move sharpguardshere to SharpCorner;
	],
	shutdown [;
		StopDaemon(self);
		remove self;
		remove sharpguardshere;
	],
	agitated [ val;
		if (val < 0) {
			self.number = -1;
			StopDaemon(self);
		}
		else {
			if (self.number == 0) {
				self.number = val;
				StartDaemon(self);
			}
		}
	],
	number 0, ! stage of shotness
	number2 0, ! daemon counter
	daemon [;
		if (location ~= parent(self))
			return; 
		self.number2++;
		switch (self.number2) {
			0, 1: 
				! do nothing
			2, 7: 
				print "^    ,      .^";
			3, 6:
				print "^        .^";
			4, 8:
				print "^   .^";
			5, 9:
				print "^    -     .^";
			default:
				print "^  -    .^";
		}
	],
  has animate pluralname static;  ! general means heard once

Object sharpguardshere "/ "
  with
	name '' '' '' '' '' '' 'standing',
	describe [;
		switch (sharpguards.number) {
			0:
				print "^        .^";
			1:
				print "^        .^";
			2:
				print "^    ,       .^";
			3, 4:
				print "^    ,      .^";
			-1:
				print "^     ,   .^";
			default:
				print "^ . []^";
		}
		rtrue;
	],
	description [;
		switch (sharpguards.number) {
			-1: "      .";
			default:
				", , .";
		}
	],
	before [;
		Examine:    
			rfalse;
		Search:
			if (sharpguards.number < 0)
				"    ,       .";
			"   .";
		Attack, Push, Pull:
			if (sharpguards.number < 0)
				"   .    ,      .";
			"     -,      .";
		ThrownAt:
			"  ."; ! do better?
	],
	life [;
		ShootAttack:
			switch (sharpguards.number) {
				-1: 
					"        .";
				2:
					sharpguards.number = 3;
					"    -; ,  ,   .       .";
				3, 4:
					sharpguards.number = -1;
					"    -; ,  ,   .   --     .    ,       .     ,      .";
				default:
					" ! []";
			}
		Kiss:
			"  .";
		Ask, Tell, AskFor, Answer:
			self.orders();
			rtrue;
	],
	orders [;
		"  .";
	],
	number 0, ! 1 = here, 2 = went past (can't go back)
	daemon [;
		! not really a daemon; this is called from sharpguards.daemon.
		if (self.number == 2) {
			if (sharpguards.number < 0) {
				self.number = 1;
				"^      .";
			}
			deadflag = 3;
			"^      .        ,    .";
		}
		else if (self.number == 1) {
			if (sharpguards.number >= 0) {
				deadflag = 3;
				"^  ,    .       ,      ,      .";
			}
			return;
		}
		! else self.number = 0
		switch (sharpguards.number) {
			-1:
				if (self.number ~= 1) {
					self.number = 1;
					"^      .";
				}
			0, 1:
				deadflag = 3;
				"^   ,    ,     .    ,     ,     .";
			default:
				self.number = 1;
				"^   .     ,       .";
		}
	],
  has static pluralname animate transparent;

Object sharpguardsguns "/ " sharpguardshere
  with
	name '^' '' '',
	description "       ,   .",
	before [;
		Examine:
			rfalse;
		Take:
			if (sharpguards.number < 0)
				"    ,       ,     .";
			"       .";
		default:
			if (sharpguards.number >= 0)
				"    .";
	],
  has scenery pluralname;

[ ReachLabDoor;
	if (parent(dimguards) == 0) {
		print "^    . []^";
	}
	
	dimguards.shutdown();
	sharpguards.shutdown();
	
	labdoorguards.startup();
];

Object labdoorguards "//"
  with
	name '' '' '' '' ''
		'' '-' '-',
	description "   ,     -.",
	before [;
		Examine:
			rfalse;
		Listen:
			"  ,   -.";
		default:
			"    .";
	],
	number 0, ! time counter
	number2 0, ! door-open counter. 0 means nothing, 2 means open on the pick's
		! sufferance, 1 means closing.
	startup [;
		StartDaemon(self);
		move self to OutsideLab;
	],
	shutdown [;
		StopDaemon(self);
		remove self;
	],
	daemon [;
		if (location == LabJunction) {
			deadflag = 3;
			"^   ,    ,    .       .";
		}
		
		if (labdoor has open && self.number2 == 1) {
			give labdoor ~open;
			self.number2 = 0;
			print "^   .^";
		}
		if (labdoor has open && labdoor hasnt locked && self.number2 == 2 
			&& lockpick.work_target ~= labdoorplate) {
			self.number2 = 1;
			print "^  ,       .^";
		}
		if (labdoor hasnt open) {
			self.number2 = 0;
		}
		if (labdoor has locked && self.number2 ~= 0) {
			self.number2 = 0;
		}
				
		self.number++;
		if (location == OutsideLab) {
			switch (self.number) {
				0: ! nothing
				1:
					print "^ ,   ,    .^";
				2:
					print "^    : @<<@>>.^";
				3:
					print "^   @<<?@>>  -.^";
				4:
					print "^   . @<<  ...@>>
						@<<...,  ...@>> ,   .^";
				5:
					print "^@<<,     , ...?@>>^";
				6:
					print "^@<<@>>. @<<@>>. @<<...@>>.      .^";
				7: ! nothing
				8:
					print "^@<<- @>> --  .^";
				9:
					deadflag = 3;
					"^- ,   - .     .  ,    ,             .";
				10: ! nothing
				11:
					deadflag = 3;
					"^  , -,   .  ,    ,      .";
				default:
					"^    . []";
			}
		}
		if (location == Laboratory) {
			if (labdoor hasnt open && labdoor has locked) {
				LockedInLab();
				return;
			}
			if (self.number == 9 && labdoor has open) {
				deadflag = 3;
				"^ ,        -   . ,    ,    ,    .";
			}
			if (self.number == 11) {
				if (labdoor has open) {
					deadflag = 3;
					"^  , -,   .  ,  ,    ,      .";
				}
				else {
					print "^     .^";
				}
			}
			if (self.number > 11) {
				if (labdoor has open) {
					deadflag = 3;
					"^      .   ,    , ,   ,   .";
				}
				if (labdoor hasnt locked) {
					deadflag = 3;
					"^  .         .";
				}
			}
		}
	],
  has animate pluralname scenery;

